<?php

namespace FiloBlu\Popup\Helper;

use FiloBlu\Popup\Model\PopupFactory;
use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\Filesystem\DirectoryList;
use Magento\Framework\UrlInterface;
use Magento\Store\Model\StoreManagerInterface;

/**
 *
 */
class Data extends AbstractHelper
{
    const CUSTOM_MEDIA_PATH = 'filoblu/popup';

    protected $_storeManager;
    protected $_popupFactory;
    protected $_dir;

    /**
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param \Magento\Framework\Filesystem\DirectoryList $dir
     * @param \FiloBlu\Popup\Model\PopupFactory $popupFactory
     */
    public function __construct(
        StoreManagerInterface $storeManager,
        DirectoryList $dir,
        PopupFactory $popupFactory
    ) {
        $this->_storeManager = $storeManager;
        $this->_popupFactory = $popupFactory;
        $this->_dir = $dir;
    }

    /**
     * @return string
     * @throws \Magento\Framework\Exception\FileSystemException
     */
    public function getMediaDirectory()
    {
        return $this->_dir->getPath('media') . '/' . self::CUSTOM_MEDIA_PATH . '/';
    }

    /**
     * @return string
     * @throws \Magento\Framework\Exception\FileSystemException
     */
    public function getMediaTmpDirectory()
    {
        return $this->_dir->getPath('media') . '/tmp/';
    }

    /**
     * @param $_filename
     * @return string
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function getImageUrl($_filename)
    {
        return $this->_storeManager->getStore()->getBaseUrl(
                UrlInterface::URL_TYPE_MEDIA
            ) . self::CUSTOM_MEDIA_PATH . '/' . $_filename;
    }

}
