<?php

namespace FiloBlu\Popup\Model\Config\Source;

use FiloBlu\Popup\Model\ResourceModel\Popup\CollectionFactory;
use Magento\Framework\Escaper;
use Magento\Framework\Option\ArrayInterface;

/**
 *
 */
class Popup implements ArrayInterface
{

    protected $_collectionFactory;
    protected $_escaper;

    /**
     * @param \FiloBlu\Popup\Model\ResourceModel\Popup\CollectionFactory $collectionFactory
     * @param \Magento\Framework\Escaper $escaper
     */
    public function __construct(
        CollectionFactory $collectionFactory,
        Escaper $escaper
    ) {
        $this->_collectionFactory = $collectionFactory;
        $this->_escaper = $escaper;
    }

    /**
     * @return array
     */
    public function toOptionArray($default = false)
    {
        $collection = $this->_collectionFactory->create();
        $array = [];

        if ($default) {
            $array[] = [
                'label' => __('All Popup'),
                'value' => 0
            ];
        }

        foreach ($collection as $popup) {
            $array[] = [
                'label' => $this->_escaper->escapeQuote($popup->getId() . ' - ' . $popup->getTitle(), true),
                'value' => $popup->getId()
            ];
        }

        return $array;
    }

}
